%parameters for hexagonal grid - change parameters HERE
close all;
clear;
clc;
global r;%radius
global rc;%center radius
global nr;%height
global nc;%length
global isd;%inter site distance
global penLoss;
global mSignalPower;%Macro transmitter signal power Outer Area(43dBm)=~20watts
global mInnerSignalPower;%Macro transmitter signal power Inner Area
global WGNVariance;
global numberofusers;
global f;%(Mhz)
global ht;%(m) base antenna height
global hm;%(m) mobile antenna height
global minfreq;
global freqstep;
global maxfreq;
global Df;

r=2;
rc=0.9;
nr=3;
nc=6;
isd=500;
penLoss = 0;
mSignalPower = 20;
mInnerSignalPower = 20;
WGNVariance = 10^-10;
numberofusers=20*nr*nc;
f=2000;
ht=30;
hm=2;
Df = 10000000;
BER = 10^-6;
a = -1.5 / log(5 * BER);
minfreq=0;
freqstep=375000;
maxfreq=10000000;

%generate cells' centers
[centerX centerY]=generate_cells_centers();
[green_cells blue_cells red_cells]=colorize_cells(centerX,centerY);
[userX userY userBaseX userBaseY userType]=generate_users(centerX,centerY,green_cells,blue_cells,red_cells);
[user_satisfaction, throughput] = ffr_calculation(userBaseX,userBaseY,userX,userY,userType,red_cells,blue_cells,green_cells);

max_satisfaction=0;
max_throughput=0;
for j=1:27
	for i=1:14
		if (user_satisfaction(i,j)>max_satisfaction)
			max_satisfaction=user_satisfaction(i,j);
			max_satisfaction_i=i;
			max_satisfaction_j=j;
		end
		if (throughput(i,j)>max_throughput)
			max_throughput=throughput(i,j);
			max_throughput_i=i;
			max_throughput_j=j;
		end
	end
end

% figure('Name','Average Troughput for optimal throughput','NumberTitle','off');
% hold on;
% ylabel('Throughput (bps)');
% xlabel('Range (m)');
% plot((0:(0.3*sqrt(3)/(2*r)):(r*sqrt(3)/2))*(isd/(r*sqrt(3))),throughput(:,max_throughput_j));
% hold off;
% figure('Name','User Satisfaction for optimal throughput','NumberTitle','off');
% hold on;
% ylabel('User Satisfaction');
% xlabel('Range (m)');
% plot((0:(0.3*sqrt(3)/(2*r)):(r*sqrt(3)/2))*(isd/(r*sqrt(3))),user_satisfaction(:,max_throughput_j));
% hold off;

% fprintf('optimize Throughput range=%d, spectrum=%d, user satisfaction=%f, throughput=%d\n',((max_throughput_i-1)*((0.3*sqrt(3)/(2*r))*(isd/(r*sqrt(3))))),((max_throughput_j-1)*freqstep),user_satisfaction(max_throughput_i,max_throughput_j),throughput(max_throughput_i,max_throughput_j));

% figure('Name','Average Troughput for optimal user satisfaction','NumberTitle','off');
% hold on;
% ylabel('Throughput (bps)');
% xlabel('Range (m)');
% plot((0:(0.3*sqrt(3)/(2*r)):(r*sqrt(3)/2))*(isd/(r*sqrt(3))),throughput(:,max_satisfaction_j));
% hold off;
% figure('Name','User Satisfaction for optimal user satisfaction','NumberTitle','off');
% hold on;
% ylabel('User Satisfaction');
% xlabel('Range (m)');
% plot((0:(0.3*sqrt(3)/(2*r)):(r*sqrt(3)/2))*(isd/(r*sqrt(3))),user_satisfaction(:,max_satisfaction_j));
% hold off;

% fprintf('optimize US range=%d, spectrum=%d, user satisfaction=%f, throughput=%d\n',((max_satisfaction_i-1)*((0.3*sqrt(3)/(2*r))*(isd/(r*sqrt(3))))),((max_satisfaction_j-1)*freqstep),max_satisfaction,throughput(max_satisfaction_i,max_satisfaction_j));

%metakinountai tyxaia oloi oi xristes
rc=(max_satisfaction_i-1)*(0.3*sqrt(3)/(2*r));
numberOfOuterArea=0;
numberOfInnerArea=0;
for z=1:numberofusers
	if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
		dist=sqrt((userBaseX(z)-userX(z))^2+(userBaseY(z)-userY(z))^2);
		if (dist>rc)
			numberOfOuterArea=numberOfOuterArea+1;
		else
			numberOfInnerArea=numberOfInnerArea+1;
		end
	end
end

% figure('Name','initial user grid','NumberTitle','off');
% hold on;
% plot_grid(green_cells,blue_cells,red_cells,userX,userY);
% hold off;
% axis equal;
averegedistance=0;
for z=1:numberofusers
	xdiff=userX(z)-userBaseX(z);
	ydiff=userY(z)-userBaseY(z);
	while (1) 
		if (rand()>0.5)
			userXfinal(z)=userX(z)+rand()*(r*sqrt(3)/2-xdiff);
		else
			userXfinal(z)=userX(z)-rand()*(r*sqrt(3)/2+xdiff);
		end
		if (rand()>0.5)
			userYfinal(z)=userY(z)+rand()*(r*sqrt(3)/2-ydiff);
		else
			userYfinal(z)=userY(z)-rand()*(r*sqrt(3)/2+ydiff);
		end
		if (sqrt((userBaseX(z)-userXfinal(z))^2+(userBaseY(z)-userYfinal(z))^2)<r*sqrt(3)/2)
			break;
		end
	end
	averegedistance=averegedistance+sqrt((userBaseX(z)-userXfinal(z))^2+(userBaseY(z)-userYfinal(z))^2)/numberofusers;
end
averegedistance=averegedistance*(isd/(r*sqrt(3)));
totaltime=(averegedistance/3000)*60*60;
rc=(max_satisfaction_i-1)*(0.3*sqrt(3)/(2*r));
% figure('Name','final user grid','NumberTitle','off');
% hold on;
% plot_grid(green_cells,blue_cells,red_cells,userXfinal,userYfinal);
% hold off;
% axis equal;
% edw na kanoume optimizaton gia kathe bima
for i=1:11
	totalusers=0;
	for z=1:numberofusers
		if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
			totalusers=totalusers+1;
		end
		newuserX(z)=(userX(z)+((i-1)/10*(userXfinal(z)-userX(z))));
		newuserY(z)=(userY(z)+((i-1)/10*(userYfinal(z)-userY(z))));
	end
	rcback=rc;
	[new_user_satisfaction, new_throughput] = ffr_calculation(userBaseX,userBaseY,newuserX,newuserY,userType,red_cells,blue_cells,green_cells);
	[newmax_throughput_i, newmax_throughput_j, newmax_satisfaction_i, newmax_satisfaction_j] = choose_optimal_ffr(new_user_satisfaction, new_throughput);
	
	range_us(i)=(newmax_satisfaction_i-1)*(0.3*sqrt(3)/(2*r));
	bandwidth_us(i)=(newmax_satisfaction_j-1)*freqstep;
	[min_user_throughput_us(i), max_user_throughput_us(i)]=min_max_throughput(range_us(i),bandwidth_us(i),userBaseX,userBaseY,newuserX,newuserY,userType,red_cells,blue_cells,green_cells);
	average_user_throughtput_us(i)=new_throughput(newmax_satisfaction_i, newmax_satisfaction_j)/totalusers;
	
	range_th(i)=(newmax_throughput_i-1)*(0.3*sqrt(3)/(2*r));
	bandwidth_th(i)=(newmax_throughput_j-1)*freqstep;
	[min_user_throughput_th(i), max_user_throughput_th(i)]=min_max_throughput(range_th(i),bandwidth_th(i),userBaseX,userBaseY,newuserX,newuserY,userType,red_cells,blue_cells,green_cells);
	average_user_throughtput_th(i)=new_throughput(newmax_throughput_i, newmax_throughput_j)/totalusers;
	
	fprintf('optimize Throughput range=%d, spectrum=%d, user satisfaction=%f, throughput=%d\n',((newmax_throughput_i-1)*((0.3*sqrt(3)/(2*r))*(isd/(r*sqrt(3))))),((newmax_throughput_j-1)*freqstep),new_user_satisfaction(newmax_throughput_i,newmax_throughput_j),new_throughput(newmax_throughput_i,newmax_throughput_j));
	fprintf('optimize Throughput i=%d, j=%d\n',newmax_throughput_i,newmax_throughput_j);
	fprintf('optimize us i=%d, j=%d\n',newmax_satisfaction_i,newmax_satisfaction_j);
	addaptive_throughput_th(i)=new_throughput(newmax_throughput_i, newmax_throughput_j);
	addaptive_usersatisfaction_th(i)=new_user_satisfaction(newmax_throughput_i, newmax_throughput_j);
	addaptive_throughput_us(i)=new_throughput(newmax_satisfaction_i, newmax_satisfaction_j);
	addaptive_usersatisfaction_us(i)=new_user_satisfaction(newmax_satisfaction_i, newmax_satisfaction_j);
	rc=rcback;
end


%user satisfaction
rc=(max_satisfaction_i-1)*(0.3*sqrt(3)/(2*r));
numberOfOuterArea=0;
numberOfInnerArea=0;
for z=1:numberofusers
	if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
		dist=sqrt((userBaseX(z)-userX(z))^2+(userBaseY(z)-userY(z))^2);
		if (dist>rc)
			numberOfOuterArea=numberOfOuterArea+1;
		else
			numberOfInnerArea=numberOfInnerArea+1;
		end
	end
end
bd=(max_satisfaction_j-1)*freqstep;

for i=1:11 %steps of moving
	newthroughput_us(i)=0;
	maxthroughput=0;
	totalusers=0;
	for z=1:numberofusers
		if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
			totalusers=totalusers+1;			
			[user_area(z) user_sinr(z)]=sinr((userX(z)+((i-1)/10*(userXfinal(z)-userX(z)))),(userY(z)+((i-1)/10*(userYfinal(z)-userY(z)))),userBaseX(z),userBaseY(z),userType(z),red_cells,blue_cells,green_cells);
			if (user_area(z)==0)
				capacity = ((Df-bd)/(3*numberOfOuterArea)) * log2(1 + user_sinr(z));
				newthroughput_us(i) = newthroughput_us(i)+0.6*capacity;
				if maxthroughput<(0.6*capacity)
					maxthroughput=0.6*capacity;
				end
			else
				capacity = (bd/numberOfInnerArea) * log2(1 + user_sinr(z));
				newthroughput_us(i) = newthroughput_us(i)+0.6*capacity;
				if maxthroughput<(0.6*capacity)
					maxthroughput=0.6*capacity;
				end
			end
		end
	end
	newuser_satisfaction_us(i)=newthroughput_us(i)/(maxthroughput*totalusers);
end

%throughput
rc=(max_throughput_i-1)*(0.3*sqrt(3)/(2*r));
numberOfOuterArea=0;
numberOfInnerArea=0;
for z=1:numberofusers
	if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
		dist=sqrt((userBaseX(z)-userX(z))^2+(userBaseY(z)-userY(z))^2);
		if (dist>rc)
			numberOfOuterArea=numberOfOuterArea+1;
		else
			numberOfInnerArea=numberOfInnerArea+1;
		end
	end
end
bd=(max_throughput_j-1)*freqstep;
for i=1:11 %steps of moving
	newthroughput_th(i)=0;
	maxthroughput=0;
	totalusers=0;
	for z=1:numberofusers
		if ((userBaseX(z)==red_cells(3,1))&&(userBaseY(z)==red_cells(3,2)))
			totalusers=totalusers+1;
			[user_area(z) user_sinr(z)]=sinr((userX(z)+((i-1)/10*(userXfinal(z)-userX(z)))),(userY(z)+((i-1)/10*(userYfinal(z)-userY(z)))),userBaseX(z),userBaseY(z),userType(z),red_cells,blue_cells,green_cells);
			if (user_area(z)==0)
				capacity = ((Df-bd)/(3*numberOfOuterArea)) * log2(1 + user_sinr(z));
				newthroughput_th(i) = newthroughput_th(i)+0.6*capacity;
				if maxthroughput<(0.6*capacity)
					maxthroughput=0.6*capacity;
				end
			else
				capacity = (bd/numberOfInnerArea) * log2(1 + user_sinr(z));
				newthroughput_th(i) = newthroughput_th(i)+0.6*capacity;
				if maxthroughput<(0.6*capacity)
					maxthroughput=0.6*capacity;
				end
			end
		end
	end
	newuser_satisfaction_th(i)=newthroughput_th(i)/(maxthroughput*totalusers);
end


figure('Name','Throughput smooth','NumberTitle','off');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),newuser_satisfaction_th);
[x3,x4]=smoothLine((0:(totaltime/10):totaltime),newthroughput_th);
[AX,H1,H2]=plotyy(x1,x2,x3,x4);
set(get(AX(1),'Ylabel'),'String','User Satisfaction');
set(get(AX(2),'Ylabel'),'String','Throughput (bps)');
xlabel('Time (sec)');
set(H1,'DisplayName','US Without Addaptation');
% set(H1,'Marker','+');
set(H2,'DisplayName','Throughtput Without Addaptation');
% set(H2,'Marker','*');
hold on;
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),addaptive_usersatisfaction_th);
[x3,x4]=smoothLine((0:(totaltime/10):totaltime),addaptive_throughput_th);
[AX,H1,H2]=plotyy(x1,x2,x3,x4);
set(H1,'DisplayName','US With Addaptation');
% set(H1,'Marker','o');
set(H2,'DisplayName','Throughtput With Addaptation');
% set(H2,'Marker','X');
hold off;


figure('Name','User Satisfaction smooth','NumberTitle','off');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),newuser_satisfaction_us);
[x3,x4]=smoothLine((0:(totaltime/10):totaltime),newthroughput_us);
[AX,H1,H2]=plotyy(x1,x2,x3,x4);
set(get(AX(1),'Ylabel'),'String','User Satisfaction');
set(get(AX(2),'Ylabel'),'String','Throughput (bps)');
xlabel('Time (sec)');
set(H1,'DisplayName','US Without Addaptation');
% set(H1,'Marker','+');
set(H2,'DisplayName','Throughtput Without Addaptation');
% set(H2,'Marker','*');
hold on;
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),addaptive_usersatisfaction_us);
[x3,x4]=smoothLine((0:(totaltime/10):totaltime),addaptive_throughput_us);
[AX,H1,H2]=plotyy(x1,x2,x3,x4);
set(H1,'DisplayName','US With Addaptation');
% set(H1,'Marker','o');
set(H2,'DisplayName','Throughtput With Addaptation');
% set(H2,'Marker','X');
hold off;


figure('Name','Min-Max-Avg Throughput','NumberTitle','off')
subplot(2,1,1);
hold on;
ylabel('Throughput (bps)');
xlabel('Time (sec)');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),min_user_throughput_us);
h=plot(x1,x2);
set(h,'DisplayName','Min User Throughput based User Satisfaction');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),max_user_throughput_us);
h=plot(x1,x2);
set(h,'DisplayName','Max User Throughput based User Satisfaction');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),average_user_throughtput_us);
h=plot(x1,x2);
set(h,'DisplayName','Average User Throughput based User Satisfaction');
hold off;
legend show;
subplot(2,1,2);
hold on;
ylabel('Throughput (bps)');
xlabel('Time (sec)');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),min_user_throughput_th);
h=plot(x1,x2);
set(h,'DisplayName','Min User Throughput based Throughput');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),max_user_throughput_th);
h=plot(x1,x2);
set(h,'DisplayName','Max User Throughput based Throughput');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),average_user_throughtput_th);
h=plot(x1,x2);
set(h,'DisplayName','Average User Throughput based Throughput');
hold off;
legend show;

for i=1:11
	range_non_adapted_th(i)=(max_throughput_i-1)*(0.3*sqrt(3)/(2*r));
	range_non_adapted_us(i)=(max_satisfaction_i-1)*(0.3*sqrt(3)/(2*r));
	bandwidth_non_adapted_th(i)=(max_throughput_j-1)*freqstep;
	bandwidth_non_adapted_us(i)=(max_satisfaction_j-1)*freqstep;
end
figure('Name','Compare','NumberTitle','off')
subplot(2,1,1);
hold on;
ylabel('Subcariers allocation of Inner-cell area');
xlabel('Time (sec)');
h=plot((0:(totaltime/10):totaltime),bandwidth_us/freqstep);
set(h,'DisplayName','Bandwidth allocation of Inner-cell area based on User Satisfaction with adaptation');
h=plot((0:(totaltime/10):totaltime),bandwidth_non_adapted_us/freqstep);
set(h,'DisplayName','Bandwidth allocation of Inner-cell area based on User Satisfaction without adaptation');
h=plot((0:(totaltime/10):totaltime),bandwidth_th/freqstep);
set(h,'DisplayName','Bandwidth allocation of Inner-cell area based on Throughput with adaptation');
h=plot((0:(totaltime/10):totaltime),bandwidth_non_adapted_th/freqstep);
set(h,'DisplayName','Bandwidth allocation of Inner-cell area based on Throughput without adaptation');
hold off;
legend show;

subplot(2,1,2);
hold on;
ylabel('Range of Inner-cell area (m)');
xlabel('Time (sec)');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),range_us*(isd/(r*sqrt(3))));
h=plot(x1,x2);
set(h,'DisplayName','Range of Inner-cell area based on User Satisfaction with adaptation');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),range_non_adapted_us*(isd/(r*sqrt(3))));
h=plot(x1,x2);
set(h,'DisplayName','Range of Inner-cell area based on User Satisfaction without adaptation');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),range_th*(isd/(r*sqrt(3))));
h=plot(x1,x2);
set(h,'DisplayName','Range of Inner-cell area based on Throughput with adaptation');
[x1,x2]=smoothLine((0:(totaltime/10):totaltime),range_non_adapted_th*(isd/(r*sqrt(3))));
h=plot(x1,x2);
set(h,'DisplayName','Range of Inner-cell area based on Throughput without adaptation');

hold off;
legend show;

